"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable react/jsx-no-leaked-render */
/* eslint-disable jsx-a11y/no-static-element-interactions */
const react_1 = __importStar(require("react"));
const icon_js_1 = require("./icon.js");
const context_js_1 = require("../context.js");
const EyeDropper_js_1 = __importDefault(require("./EyeDropper.js"));
const constants_js_1 = require("../constants.js");
const AdvancedControls_js_1 = __importDefault(require("./AdvancedControls.js"));
const ComparibleColors_js_1 = __importDefault(require("./ComparibleColors.js"));
const GradientControls_js_1 = __importDefault(require("./GradientControls.js"));
const styles_js_1 = require("../styles/styles.js");
const { defaultColor, defaultGradient } = constants_js_1.config;
const ColorTypeBtns = ({ hideColorTypeBtns, isGradient, setSolid, setGradient, locales, }) => {
    const { defaultStyles } = (0, context_js_1.usePicker)();
    if (hideColorTypeBtns) {
        return react_1.default.createElement("div", { style: { width: 1 } });
    }
    else {
        return (react_1.default.createElement("div", { style: defaultStyles.controlBtnWrapper },
            react_1.default.createElement("div", { onClick: setSolid, id: "rbgcp-solid-btn", style: (0, styles_js_1.colorTypeBtnStyles)(!isGradient, defaultStyles) }, locales?.CONTROLS?.SOLID),
            react_1.default.createElement("div", { onClick: setGradient, id: "rbgcp-gradient-btn", style: (0, styles_js_1.colorTypeBtnStyles)(isGradient || false, defaultStyles) }, locales?.CONTROLS?.GRADIENT)));
    }
};
const InputTypeDropdown = ({ openInputType, setOpenInputType, }) => {
    const { inputType, setInputType, defaultStyles } = (0, context_js_1.usePicker)();
    const vTrans = openInputType
        ? 'visibility 0ms linear'
        : 'visibility 100ms linear 150ms';
    const zTrans = openInputType
        ? 'z-index 0ms linear'
        : 'z-index 100ms linear 150ms';
    const oTrans = openInputType
        ? 'opacity 120ms linear'
        : 'opacity 150ms linear 50ms';
    const handleInputType = (e, val) => {
        if (openInputType) {
            e.stopPropagation();
            setInputType(val);
            setOpenInputType(false);
        }
    };
    return (react_1.default.createElement("div", { style: {
            visibility: openInputType ? 'visible' : 'hidden',
            zIndex: openInputType ? '' : -100,
            opacity: openInputType ? 1 : 0,
            transition: `${oTrans}, ${vTrans}, ${zTrans}`,
            ...defaultStyles.rbgcpColorModelDropdown,
        } },
        react_1.default.createElement("div", { onClick: (e) => handleInputType(e, 'rgb'), style: (0, styles_js_1.modalBtnStyles)(inputType === 'rgb', defaultStyles) }, "RGB"),
        react_1.default.createElement("div", { onClick: (e) => handleInputType(e, 'hsl'), style: (0, styles_js_1.modalBtnStyles)(inputType === 'hsl', defaultStyles) }, "HSL"),
        react_1.default.createElement("div", { onClick: (e) => handleInputType(e, 'hsv'), style: (0, styles_js_1.modalBtnStyles)(inputType === 'hsv', defaultStyles) }, "HSV"),
        react_1.default.createElement("div", { onClick: (e) => handleInputType(e, 'cmyk'), style: (0, styles_js_1.modalBtnStyles)(inputType === 'cmyk', defaultStyles) }, "CMYK")));
};
const Controls = ({ locales, hideEyeDrop = false, hideAdvancedSliders = false, hideColorGuide = false, hideInputType = false, hideColorTypeBtns = false, hideGradientControls = false, hideGradientType = false, hideGradientAngle = false, hideGradientStop = false, }) => {
    const { onChange, isGradient, handleChange, previous, defaultStyles } = (0, context_js_1.usePicker)();
    const [openComparibles, setOpenComparibles] = (0, react_1.useState)(false);
    const [openInputType, setOpenInputType] = (0, react_1.useState)(false);
    const [openAdvanced, setOpenAdvanced] = (0, react_1.useState)(false);
    const noTools = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    const solidColor = previous?.color || defaultColor;
    const gradientColor = previous?.gradient || defaultGradient;
    const setSolid = () => {
        onChange(solidColor);
    };
    const setGradient = () => {
        onChange(gradientColor);
    };
    const allRightControlsHidden = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    const allControlsHidden = allRightControlsHidden && hideColorTypeBtns;
    if (allControlsHidden) {
        if (isGradient && !hideGradientControls) {
            return (react_1.default.createElement(GradientControls_js_1.default, { hideGradientType: hideGradientType, hideGradientAngle: hideGradientAngle, hideGradientStop: hideGradientStop }));
        }
        else {
            return null;
        }
    }
    else {
        return (react_1.default.createElement("div", { style: { paddingTop: 12, paddingBottom: 4 } },
            react_1.default.createElement("div", { style: {
                    width: '100%',
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'space-between',
                } },
                react_1.default.createElement(ColorTypeBtns, { hideColorTypeBtns: hideColorTypeBtns, setGradient: setGradient, isGradient: isGradient, setSolid: setSolid, locales: locales }),
                !allRightControlsHidden && (react_1.default.createElement("div", { style: {
                        display: noTools ? 'none' : '',
                        ...defaultStyles.rbgcpControlBtnWrapper,
                    } },
                    !hideEyeDrop && react_1.default.createElement(EyeDropper_js_1.default, { onSelect: handleChange }),
                    react_1.default.createElement("div", { id: "rbgcp-advanced-btn", onClick: () => setOpenAdvanced(!openAdvanced), style: {
                            display: hideAdvancedSliders ? 'none' : 'flex',
                            ...(0, styles_js_1.controlBtnStyles)(openAdvanced, defaultStyles),
                        } },
                        react_1.default.createElement(icon_js_1.SlidersIcon, { color: openAdvanced ? '#568CF5' : '' })),
                    react_1.default.createElement("div", { id: "rbgcp-comparibles-btn", style: {
                            display: hideColorGuide ? 'none' : 'flex',
                            ...(0, styles_js_1.controlBtnStyles)(openComparibles, defaultStyles),
                        }, onClick: () => setOpenComparibles(!openComparibles) },
                        react_1.default.createElement(icon_js_1.PaletteIcon, { color: openComparibles ? '#568CF5' : '' })),
                    react_1.default.createElement("div", { id: "rbgcp-color-model-btn", onClick: () => setOpenInputType(!openInputType), style: {
                            display: hideInputType ? 'none' : 'flex',
                            ...(0, styles_js_1.controlBtnStyles)(openInputType, defaultStyles),
                        } },
                        react_1.default.createElement(icon_js_1.InputsIcon, { color: openInputType ? '#568CF5' : '' }),
                        react_1.default.createElement(InputTypeDropdown, { openInputType: openInputType, setOpenInputType: setOpenInputType }))))),
            !hideAdvancedSliders && (react_1.default.createElement(AdvancedControls_js_1.default, { openAdvanced: openAdvanced })),
            !hideColorGuide && (react_1.default.createElement(ComparibleColors_js_1.default, { openComparibles: openComparibles })),
            isGradient && !hideGradientControls && (react_1.default.createElement(GradientControls_js_1.default, { hideGradientType: hideGradientType, hideGradientAngle: hideGradientAngle, hideGradientStop: hideGradientStop }))));
    }
};
exports.default = Controls;
